<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Go event sourcing</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-eOJMYsd53ii+scO/bJGFsiCZc+5NDVN2yr8+0RDqr0Ql0h+rP48ckxlpbzKgwra6" crossorigin="anonymous">
</head>
<style>
    .messages {
        border-radius: 5px;
        border: 1px black dashed;
        height: 500px;
        overflow-y: auto;
    }

    #messages {
        padding: 0;
    }

    #messages li {
        list-style: none;
        padding: 3px;
        border-radius: 5px;
        border: 1px gray solid;
        margin: 5px;
    }
</style>
<body>
<div class="container my-5">
    <div class="input-group mb-3">
        <input type="text" class="form-control" placeholder="New message" id="new-message-input">
        <button class="btn btn-outline-secondary" type="button" id="new-message-button-send">Send</button>
    </div>
    <div class="messages">
        <ul id="messages">

        </ul>
    </div>
</div>
</body>
<script>
    document.addEventListener("DOMContentLoaded", function () {
        let sendUserId = Math.random().toString(36).substring(7);

        const messageSource = new EventSource(`/echo?w=hello&user_id=${sendUserId}`);
        messageSource.onmessage = function (event) {
            const newElement = document.createElement('li');
            const eventList = document.getElementById('messages');

            newElement.innerHTML = event.data;
            eventList.prepend(newElement);
        };
        messageSource.onerror = function (error) {
            console.error("⛔ EventSource failed: ", error);
        };

        let sendNewMessageBtn = document.getElementById('new-message-button-send');
        sendNewMessageBtn.addEventListener('click', function (_) {
            let messageInput = document.getElementById('new-message-input');
            let message = messageInput.value;

            if (!!message) {
                let xhr = new XMLHttpRequest();
                xhr.onreadystatechange = function () {
                };
                xhr.open('GET', `/say?w=${message}`);
                xhr.setRequestHeader('User-Id', sendUserId);
                xhr.send();
            }
        })

        let messageInput = document.getElementById('new-message-input');
        messageInput.addEventListener('keyup', function (event) {
            if (event.key === 'Enter') {
                event.preventDefault();

                sendNewMessageBtn.click();
                messageInput.value = "";
            }
        })
    });
</script>
</html>